<?php

/* ======================================================================*\
  || #################################################################### ||
  || # vBulletin 4.2.0 Patch Level 3 - Licence Number VBSB9B594A
  || # ---------------------------------------------------------------- # ||
  || # Copyright 2000-2012 vBulletin Solutions Inc. All Rights Reserved. ||
  || # This file may not be redistributed in whole or significant part. # ||
  || # ---------------- VBULLETIN IS NOT FREE SOFTWARE ---------------- # ||
  || # http://www.vbulletin.com | http://www.vbulletin.com/license.html # ||
  || #################################################################### ||
  \*====================================================================== */

/**
 * Class to populate the activity stream from existing content
 *
 * @package	vBulletin
 * @version	$Revision: 57655 $
 * @date		$Date: 2012-01-09 12:08:39 -0800 (Mon, 09 Jan 2012) $
 */
class vB_ActivityStream_Populate_Blog_Comment extends vB_ActivityStream_Populate_Base
{
	/**
	 * Constructor - set Options
	 *
	 */
	public function __construct()
	{
		return parent::__construct();
	}

	/*
	 * Don't get: Deleted threads, redirect threads, CMS comment threads
	 *
	 */
	public function populate()
	{
		if (!vB::$vbulletin->products['vbblog'])
		{
			return;
		}

		$typeid = vB::$vbulletin->activitystream['blog_comment']['typeid'];
		$this->delete($typeid);

		if (!vB::$vbulletin->activitystream['blog_comment']['enabled'])
		{
			return;
		}

		$timespan = TIMENOW - vB::$vbulletin->options['as_expire'] * 60 * 60 * 24;
		vB::$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "activitystream
				(userid, dateline, contentid, typeid, action)
				(SELECT
					bt.userid, bt.dateline, bt.blogtextid, '{$typeid}', 'create'
				FROM " . TABLE_PREFIX . "blog_text AS bt
				LEFT JOIN " . TABLE_PREFIX . "blog AS b ON (b.blogid = bt.blogid)
				WHERE
					bt.dateline >= {$timespan}
						AND
					b.state NOT IN ('draft')
						AND
					b.pending = 0
						AND
					b.firstblogtextid <> bt.blogtextid
				)
		");
	}
}

/*======================================================================*\
|| ####################################################################
|| # Downloaded: 21:36, Thu Dec 6th 2012
|| # CVS: $RCSfile$ - $Revision: 57655 $
|| ####################################################################
\*======================================================================*/